from typing import List, Tuple

from sohstationviewer.view.util.color import clr


def get_colors_sizes_for_abs_y_from_value_colors(
        y: List[float],
        value_colors: List[Tuple[float, str]]) -> \
        Tuple[List[str], List[float]]:
    """
    Map each abs(value) in y with the value in value_colors to get the colors
    for the indexes corresponding to the y's items.
    Sizes is currently similar for all items
    :param y: list of data values
    :param value_colors: list of color with indexes corresponding to y's items
    :return colors: list of colors of markers corresponding to y
    :return sizes: list of sizes of markers corresponding to y
    """
    colors = [None] * len(y)
    sizes = [1.5] * len(y)
    for i in range(len(y)):
        count = -1
        for v, c in value_colors:
            count += 1
            if count <= len(value_colors) - 2:
                if abs(y[i]) <= v:
                    colors[i] = clr[c]
                    break
            else:
                # The last value color
                colors[i] = clr[c]
    return colors, sizes
